#ifndef DISASSEMBLERVIEW_H
#define DISASSEMBLERVIEW_H

#include "abstractviewwidget.h"
#include <QListWidget>
#include <QStringList>
#include <QByteArray>

class DisassemblerView : public QListWidget
{
    Q_OBJECT
public:
    enum Type {ScratchPad,DynamicCog};
    DisassemblerView(Type type, int cogId, MemoryMap *newMap);
    void updateFunctionEntries(QList<AsmFunctionEntry> functions);
public slots:
    void checkIfMemoryChanged();
private:
    void addEntry(AsmFunctionEntry f);
    void doUpdate(bool force);
    QStringList disassemble(QByteArray data, AsmFunctionEntry f);
    quint8* getBasePointerOfNewMap() const;
    struct Entry {
        AsmFunctionEntry f;
        QByteArray prevMem;
        QStringList prevResult;
    };
    MemoryMap *m_newMap;
    Type m_type;
    int m_cogId;
    QList<Entry> m_entries;
};

#endif // DISASSEMBLERVIEW_H
