#ifndef REGISTERVIEWWIDGET_H
#define REGISTERVIEWWIDGET_H

#include <QListWidget>
#include "abstractviewwidget.h"

struct RegisterInfo {
    enum Type {Boolean,UInt32,UInt64,Pointer};
    RegisterInfo():type(Boolean),relativeOffset(0) {}
    QString name;
    Type type;
    int relativeOffset;
};

class RegisterViewWidget : public QListWidget
{
    Q_OBJECT
public:
    RegisterViewWidget(int cogIdOrHub, MemoryMap *newMap, MemoryMap *oldMap);
    void updateRegisterDefinitions(QList<RegisterInfo> registers);
    bool isHubRegs() const { return m_cogIdOrHub<0; }
public slots:
    void checkIfMemoryChanged();
private:
    QString getRegisterLine(const RegisterInfo& r) const;
    MemoryMap *m_newMap;
    MemoryMap *m_oldMap;
    QList<RegisterInfo> m_registers;
    int m_cogIdOrHub;
};

#endif // REGISTERVIEWWIDGET_H
