#include "viewwidgetcontainer.h"
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QLabel>
#include <QToolButton>
#include <QtDebug>

ViewWidgetContainer::ViewWidgetContainer(QWidget *view, QWidget *parent, QString typeId, QWidget *mainWidget):
    QWidget(parent),
    m_view(view),
    m_typeId(typeId)
{
    auto l1 = new QVBoxLayout(this);
    auto l2 = new QHBoxLayout();
    l1->addLayout(l2);
    auto btn = new QToolButton(this);
    btn->setText("X");
    l2->addWidget(new QLabel(view->windowTitle(), this));
    l2->addWidget(btn);
    l1->addWidget(view);

    connect(mainWidget,SIGNAL(verifyMemorySignal()),view,SLOT(checkIfMemoryChanged()));
    connect(btn,SIGNAL(clicked()),this,SLOT(closeBtnClicked()));
    connect(this,SIGNAL(closeRequested()),mainWidget,SLOT(viewCloseRequested()));

}

void ViewWidgetContainer::closeBtnClicked() {
    emit closeRequested();
}
