package ilang

fun mergeSwitchBranches(stm:SwitchStatement):SwitchStatement {
    val result = ArrayList<SwitchStatement.Case>()
    val remainingCases = ArrayList(stm.cases)
    while (remainingCases.isNotEmpty()) {
        val masterCase = remainingCases.removeFirst()
        val masterValues = ArrayList(masterCase.values)
        val notUsedCases = ArrayList<SwitchStatement.Case>()
        for (c in remainingCases) {
            if (isSameStatementList(masterCase.body,c.body))
                masterValues.addAll(c.values)
            else
                notUsedCases.add(c)
        }
        remainingCases.clear()
        remainingCases.addAll(notUsedCases)
        result.add(SwitchStatement.Case(masterValues, masterCase.body))
    }
    return stm.modified(stm.expr,result)
}

//Hier werden switch/case branches mit gleichen statements zusammengefasst um den code kompakter zu halten
//Die Funktion kann sehr langsam sein
fun removeCommonBranches(rootStm:List<Statement>):List<Statement> {
    val result = ArrayList<Statement>()
    for (stm in rootStm) {
        result.add(when(stm) {
            is LetStatement, is LetArrayStatement -> stm
            is SwitchStatement -> {
                val optStm = stm.modified(stm.expr, stm.cases.map { it.modified(removeCommonBranches(it.body)) }) //kinder optimieren
                //nun muss geprüft werden, ob cases zusammengeführt werden können
                mergeSwitchBranches(optStm)
            }
            is MacroStatement -> throw Exception("Macro Statement not allowed here")
        })
    }
    return useNewStatements(rootStm, result)
}

fun removeCommonBranches(function: Function):Function = function.modified(removeCommonBranches(function.body))