package special

import ilang.*
import ilang.Function
import java.lang.Exception

//Extrahiert die let cond,... Zeile an den Anfang

class ExtractedConditionCode(origFun:Function, running:Boolean, neverFwdVars:List<ILangVariable>) {
    val condFalseFunction:Function
    val condTrueFunction:Function
    val condition:Expression
    init {
        val condVar = origFun.getVariableByName("cond")
        val firstCondLetStm = findFirstLetStatement(condVar, origFun.body) ?: throw Exception("no let cond stm found")
        condition = (origFun.body[firstCondLetStm] as LetStatement).expr
        val conditionStmStr = origFun.body[firstCondLetStm].toString()
        val expectedCondStr = if (running)
            "let cond (andB (notB cancel) (testBit32 (shr32 (and32 (shr32 instruction_reg 0I12) 0If) (or32 (mux32 zflag 0I1 0I0) (mux32 cflag 0I2 0I0))) 0I0))"
        else
            "let cond (andB (notB cancel) (testBit32 (shr32 0I1 (or32 (mux32 zflag 0I1 0I0) (mux32 cflag 0I2 0I0))) 0I0))"
        if (conditionStmStr != expectedCondStr)
            throw Exception("invalid condition statement $conditionStmStr; expected: $expectedCondStr")
        val newBody = ArrayList(origFun.body)
        if (!trySwapStatementUp(firstCondLetStm, 0, newBody, false))
            throw Exception("unable to swap up condition statement")
        fun getConditionOptimizedFunction(cond:Boolean):Function {
            val tmpVarState=PartialValueVarState()
            for (nf in neverFwdVars)
                tmpVarState.setNeverForwardVariable(nf)
            return removeUnsuedLocals(
                simplifyFunction(
                    origFun.modified(listOf(
                        LetStatement(condVar,
                            ConstantExpression(if (cond) 1UL else 0UL, ILangDataType.Bool)
                        )
                    )+newBody.subList(1,newBody.size)),tmpVarState
                )
            )
        }
        condFalseFunction = getConditionOptimizedFunction(false)
        condTrueFunction = getConditionOptimizedFunction(true)
    }
}
