package special

import ilang.*
import ilang.Function

fun addCounterMaskAndVidVars(cogRegs:ILangVariableSet) {
    cogRegs.addVariable(ILangVariable("reg_cog_ctra_ctramask",ILangDataType.Int32,ILangVariableDirection.Register))
    cogRegs.addVariable(ILangVariable("reg_cog_ctra_ctrbmask",ILangDataType.Int32,ILangVariableDirection.Register))
    cogRegs.addVariable(ILangVariable("reg_cog_ctrb_ctramask",ILangDataType.Int32,ILangVariableDirection.Register))
    cogRegs.addVariable(ILangVariable("reg_cog_ctrb_ctrbmask",ILangDataType.Int32,ILangVariableDirection.Register))
    cogRegs.addVariable(ILangVariable("reg_cog_vid_vcfg_chroma",ILangDataType.Int32,ILangVariableDirection.Register))
    cogRegs.addVariable(ILangVariable("reg_cog_vid_lastvidclk",ILangDataType.Bool,ILangVariableDirection.Register))
}

fun removeCounterPinAndVidVars(cogRegs: ILangVariableSet) {
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_ctra_ctrapin")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_ctra_ctrbpin")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_ctrb_ctrapin")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_ctrb_ctrbpin")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_vid_vcfg_chroma0")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_vid_vcfg_chroma1")!!)
    cogRegs.removeVariable(cogRegs.getVariable("reg_cog_vid_vcfg_cmode")!!)
}

fun transferPinToMaskMap(f:Function) = hashMapOf(
    f.getVariableByName("reg_cog_ctra_ctrapin") to f.getVariableByName("reg_cog_ctra_ctramask"),
    f.getVariableByName("reg_cog_ctra_ctrbpin") to f.getVariableByName("reg_cog_ctra_ctrbmask"),
    f.getVariableByName("reg_cog_ctrb_ctrapin") to f.getVariableByName("reg_cog_ctrb_ctramask"),
    f.getVariableByName("reg_cog_ctrb_ctrbpin") to f.getVariableByName("reg_cog_ctrb_ctrbmask")
)

//reg_cog_ctrX_ctrYpin -> reg_cog_ctrX_ctrYmask
fun transformCogClkPeripherals(f:Function,snc1RisingEdgeBody:Function):Function {
    val pinInWireVar = f.getVariableByName("pin_in_wire")
    val varMap = transferPinToMaskMap(f)
    val f1= f.modified(mapExpressionsRecursive(f.body) {
            expr ->
        //früher (eq32 (and32 (shr32 pin_in_wire reg_cog_ctrX_ctrYpin) 0I1) 0I1) -> (neq32 (and32 pin_in_wire reg_cog_ctrX_ctrYmask) 0I0)
        //jetzt (testBit32 (shr32 pin_in_wire reg_cog_ctrX_ctrYpin) 0I0) -> (neq32 (and32 pin_in_wire reg_cog_ctrX_ctrYmask) 0I0)
        /*if (expr is EqualityExpression && expr.isEq && expr.right is ConstantExpression && expr.right.value == 1UL &&
            expr.left is AdditiveOrBitwiseExpression && !expr.left.withFlags && expr.left.operation == AdditiveOrBitwiseExpression.Operation.And && expr.left.right is ConstantExpression && expr.left.right.value == 1UL &&
            expr.left.left is ShiftExpression && !expr.left.left.shiftLeft &&
                expr.left.left.left is VariableExpression && expr.left.left.left.variable === pinInWireVar && expr.left.left.right is VariableExpression) {
            val oldPinVar = expr.left.left.right.variable
            val newMaskVar = varMap[oldPinVar] ?: throw Exception("no var $oldPinVar found")
            opNeq32(opAnd32(VariableExpression(pinInWireVar),VariableExpression(newMaskVar)), opConst32(0UL))
        }*/
        if (expr is TestBitExpression && expr.bitNo is ConstantExpression && expr.bitNo.value == 0UL && expr.expr is ShiftExpression) {
            val oldShiftExpr = expr.expr
            if (!oldShiftExpr.shiftLeft && !oldShiftExpr.withFlags && oldShiftExpr.left is VariableExpression && oldShiftExpr.left.variable === pinInWireVar && oldShiftExpr.right is VariableExpression) {
                val oldPinVar = oldShiftExpr.right.variable
                val newMaskVar = varMap[oldPinVar] ?: throw Exception("no var $oldPinVar found")
                opNeq32(opAnd32(VariableExpression(pinInWireVar), VariableExpression(newMaskVar)), opConst32(0UL))
            }
            else
                expr
        }
        else
            expr
    })
    fun isVidStm(stm:SwitchStatement) = stm.expr is EqualityExpression && stm.expr.left is VariableExpression && stm.expr.left.variable.name == "reg_cog_vid_vcfg_vmode"
    val f2= moveMatchingStatementsDown(f1) { it is SwitchStatement && isVidStm(it)}
    val lastVidSwitchStm = f2.body.lastOrNull() as? SwitchStatement ?: throw Exception("missing vid stm")
    if (!isVidStm(lastVidSwitchStm) || lastVidSwitchStm.matchingCase(0UL).body.isNotEmpty())
        throw Exception("missing vid stm $lastVidSwitchStm")
    //Innerhalb des if Bodys müssen sein:
    val trueVidBody = lastVidSwitchStm.matchingCase(1UL).body
    if (trueVidBody.size != 2)
        throw Exception("missing vid stm body size != 2")
    val stm1 = trueVidBody[0]
    val stm2 = trueVidBody[1]
    val snc0 = f2.getVariableByName("reg_cog_vid_snc0")
    val snc1 = f2.getVariableByName("reg_cog_vid_snc1")
    val vidCapr = f2.getVariableByName("reg_cog_vid_capr")
    //erwartet
    //regcog.reg_cog_vid_snc1 = regcog.reg_cog_vid_snc0;
    //regcog.reg_cog_vid_snc0 = regcog.reg_cog_vid_capr;
    if (stm1 !is LetStatement || stm1.destVar !== snc1 || stm1.expr !is VariableExpression || stm1.expr.variable !== snc0)
        throw Exception("invalid last vid stm1: $stm1")
    if (stm2 !is LetStatement || stm2.destVar !== snc0 || stm2.expr !is VariableExpression || stm2.expr.variable !== vidCapr)
        throw Exception("invalid last vid stm2: $stm2")
    //steigende flanke von snc1 erkennen: !snc1 && snc0 vor den beiden stms
    val posedgeSnc1 = ILangVariable("posedge_snc1",ILangDataType.Bool,ILangVariableDirection.Local)
    val posedgeSnc1Stm = LetStatement(posedgeSnc1,opAndB(opNotB(VariableExpression(snc1)),VariableExpression(snc0)))
    if (snc1RisingEdgeBody.localVarSet().getArrayVariableList().isNotEmpty())
        throw Exception("no locals allowed in snc1 rising function")
    val posedgeSnc1Trigger = SwitchStatement(VariableExpression(posedgeSnc1),listOf(
        SwitchStatement.Case(listOf(0UL),listOf()),
        SwitchStatement.Case(listOf(1UL),snc1RisingEdgeBody.body)
    ))
    return f2.localsAdded(listOf(posedgeSnc1)).modified(f2.body.dropLast(1)+listOf(lastVidSwitchStm.modified(lastVidSwitchStm.expr,listOf(
        SwitchStatement.Case(listOf(0UL),listOf()),
        SwitchStatement.Case(listOf(1UL),listOf(posedgeSnc1Stm,stm1,stm2,posedgeSnc1Trigger))),
    )))
}

fun transformPinOut(fIn:Function):Function {
    val varMap = transferPinToMaskMap(fIn)
    fun getMaskVar(pinVar:VariableExpression):VariableExpression {
        return VariableExpression(varMap[pinVar.variable] ?: throw Exception("no pin var ${pinVar.variable} found"))
    }
    fun transformShl1(expr:ShiftExpression):Expression {
        if (expr.right is VariableExpression) //shl32 1 reg_cog_ctrX_ctrYpin -> reg_cog_ctrX_ctrYmask
            return getMaskVar(expr.right)
        if (expr.right is MuxExpression && expr.right.trueExpr is VariableExpression && expr.right.falseExpr is VariableExpression) //shl32 1 (mux32 c pinA, pinB)
            return opMux32(expr.right.condition,getMaskVar(expr.right.trueExpr),getMaskVar(expr.right.falseExpr))
        return expr
    }
    val newF1= fIn.modified(mapExpressionsRecursive(fIn.body) { expr ->
        if (expr is ShiftExpression && expr.shiftLeft && expr.left is ConstantExpression && expr.left.value == 1UL)
            transformShl1(expr)
        else
            expr
    })

    fun extractMuxPllSavedInVideo(caseBody:List<Statement>):List<Statement> {
        if (caseBody.size != 1)
            throw Exception("invalid pll mux case body")
        val firstStm = caseBody.first()
        if (firstStm !is LetStatement)
            throw Exception("invalid pll mux case body")
        return listOf(
            SwitchStatement(VariableExpression(fIn.getVariableByName("reg_cog_ctrb_pll_saved")), listOf(
                SwitchStatement.Case(listOf(0UL),listOf(firstStm)),
                SwitchStatement.Case(listOf(1UL),listOf(firstStm))
            ))
        )
    }

    val newF2 = simplifyFunction(newF1.modified(mapStmList(newF1.body) {
        if (it is SwitchStatement && it.expr is VariableExpression && it.expr.variable.name == "reg_cog_vid_vcfg_vmode") {
            it.modified(it.expr,it.cases.map {
                cse->
                if (cse.values.contains(2UL) || cse.values.contains(3UL))
                    cse.modified(extractMuxPllSavedInVideo(cse.body))
                else
                    cse
            })
        }
        else
            it

    }), PartialValueVarState())

    val savedPll = newF2.getVariableByName("reg_pll_saved_both")
    val newF3 = newF2.modified(mapExpressionsRecursive(newF2.body) {
        rootExpr -> rootExpr.map {
            expr->
            if (expr is VariableExpression) {
                if (expr.variable.name == "reg_cog_ctra_pll_saved")
                    opTestBit32(VariableExpression(savedPll), opConst32(1UL))
                else if (expr.variable.name == "reg_cog_ctrb_pll_saved")
                    opTestBit32(VariableExpression(savedPll), opConst32(2UL))
                else
                    expr
            }
            else
                expr
        }
    })


    val newF4 = simplifyFunction(transformIfToMux(newF3.modified(mapExpressionsRecursive(newF3.body) {
        rootExpr->rootExpr.map {
            if (it is TestBitExpression && it.expr is VariableExpression && it.expr.variable.name == "pll_in_wire")
                GetPllOfCogExpression(it.bitNo)
            else
                it
        }
    })),PartialValueVarState())
    return newF4
}

fun transformCogControlMacroAndResetMacro(f:Function, isCogControl:Boolean):Function {
    val varMap = transferPinToMaskMap(f)
    val pinMaskReplaced=removeUnsuedLocals(simplifyFunction(f.modified(mapStmList(f.body) {
        if (it is LetStatement) {
            val newVar = varMap[it.destVar]
            if (newVar == null)
                it
            else
                LetStatement(newVar, opShl32(opConst32(1UL),it.expr))
        }
        else
            it
    }),PartialValueVarState()))

    val vidChroma = f.getVariableByName("reg_cog_vid_vcfg_chroma")
    val vidLastClk = f.getVariableByName("reg_cog_vid_lastvidclk")

    fun replLetStm(stm:LetStatement):List<LetStatement> {
        fun forceTestBit(selBit:ULong):Expression {
            if (stm.expr !is TestBitExpression)
                throw Exception("invalid stm: $stm")
            if (stm.expr.bitNo !is ConstantExpression || stm.expr.bitNo.value != selBit)
                throw Exception("invalid stm: $stm")
            return stm.expr.expr
        }
        if (isCogControl) {
            if (stm.destVar.name == "reg_cog_vid_vcfg_cmode") {
                val subExpr = forceTestBit(0x1CUL)
                return listOf(LetStatement(vidChroma, opAnd32(opShr32(subExpr,opConst32(0x1AUL)), opConst32(0x7UL))))
            }
            if (stm.destVar.name == "reg_cog_vid_vcfg_chroma0") {
                forceTestBit(0x1AUL)
                return listOf()
            }
            if (stm.destVar.name == "reg_cog_vid_vcfg_chroma1") {
                forceTestBit(0x1BUL)
                return listOf()
            }
        }
        else {
            if (stm.destVar.name == "reg_cog_vid_vcfg_cmode") {
                if (stm.expr !is ConstantExpression || stm.expr.value != 0UL)
                    throw Exception("invalid rst stm: $stm")
                return listOf(
                    LetStatement(vidChroma, opConst32(0UL)),
                    LetStatement(vidLastClk,ConstantExpression(false))
                )
            }
            if (stm.destVar.name == "reg_cog_vid_vcfg_chroma0" || stm.destVar.name == "reg_cog_vid_vcfg_chroma1") {
                if (stm.expr !is ConstantExpression || stm.expr.value != 0UL)
                    throw Exception("invalid rst stm: $stm")
                return listOf()
            }
        }
        return listOf(stm)
    }

    return pinMaskReplaced.modified(mapStmMultiList(pinMaskReplaced.body) {
        if (it !is LetStatement)
            listOf(it)
        else {
            replLetStm(it)
        }
    })
}