package special

import com.sun.source.tree.SwitchTree
import ilang.*
import ilang.Function

fun optimizeVidClkFunction(origF:Function):Function {
    fun extractBooleanVar(f:Function,varName:String, cb:(fr:Function, value:Boolean)->Function):Function {
        val v = origF.getVariableByName(varName)
        val tmpF = moveMatchingStatementsUp(f) { it is LetStatement && it.destVar === v}
        if (tmpF.body.isEmpty())
            throw Exception("expected let $varName stm")
        val firstStm = tmpF.body.first()
        if (firstStm !is LetStatement || firstStm.destVar !== v)
            throw Exception("expected let $varName stm, got $firstStm")
        fun buildBranch(value:Boolean) = cb(removeUnsuedLocals(simplifyFunction(f.modified(listOf(LetStatement(v,ConstantExpression(value)))+tmpF.body.drop(1)),PartialValueVarState())),value)

        return removeUnsuedLocals(extractCommonStmInIf(tmpF.modified(listOf(SwitchStatement(
            firstStm.expr,listOf(
                SwitchStatement.Case(listOf(1UL),buildBranch(true).body),
                SwitchStatement.Case(listOf(0UL),buildBranch(false).body)
            )
        )))))
    }
    fun transformLocalColorPhs(f:Function):Function {
        val varLocalColorPhs = f.getVariableByName("loc_cog_vid_local_colorphs")
        val varLocalColorMod = f.getVariableByName("loc_cog_vid_local_colormod")
        val localColorRegs = setOf(varLocalColorPhs,varLocalColorMod)
        val basebandAndComposite = setOf(f.getVariableByName("reg_cog_vid_baseband"),f.getVariableByName("reg_cog_vid_composite"))
        val f2=moveMatchingStatementsUp(f) { dependendVars(it).union(affectedVars(it)).vars.intersect(localColorRegs).isNotEmpty() }
        val tmpBody = ArrayList(f2.body)
        fun takeFirstLetStm(allowedVars:Set<ILangVariable>):LetStatement {
            if (tmpBody.isEmpty())
                throw Exception("expected let stm")
            val first = tmpBody.removeFirst()
            if (first !is LetStatement || !allowedVars.contains(first.destVar))
                throw Exception("expected let stm $allowedVars, got $first")
            return first
        }
        fun takeFirstAndSecondLetStm(allowedVars:Set<ILangVariable>):List<LetStatement> {
            val s1= takeFirstLetStm(allowedVars)
            val s2= takeFirstLetStm(allowedVars)
            return listOf(s1,s2)
        }
        fun takeFirstIfStm():SwitchStatement {
            if (tmpBody.isEmpty())
                throw Exception("expected switch stm")
            val first = tmpBody.removeFirst()
            if (first !is SwitchStatement || first.expr.dataType != ILangDataType.Bool)
                throw Exception("expected switch stm, got $first")
            return first
        }
        /*
        //Initial Values
        let loc_cog_vid_local_colorphs false
        let loc_cog_vid_local_colormod reg_cog_vid_discrete
        //If Stm
        if (neq32 (and32 reg_cog_vid_discrete 0I8) 0I0):
            true:
                let loc_cog_vid_local_colorphs (neq32 (and32 (add32 (and32 (shr32 reg_cog_vid_discrete 0I4) 0If) reg_cog_vid_phase) 0I8) 0I0)
                let loc_cog_vid_local_colormod (add32 reg_cog_vid_discrete (mux32 loc_cog_vid_local_colorphs 0I7 0I1))
        //SetRegs
        let reg_cog_vid_baseband (add32 (mux32 loc_cog_vid_local_colorphs 0I8 0I0) (and32 (mux32 reg_cog_vid_vcfg_chroma0 loc_cog_vid_local_colormod reg_cog_vid_discrete) 0I7))
        let reg_cog_vid_composite (and32 (mux32 reg_cog_vid_vcfg_chroma1 loc_cog_vid_local_colormod reg_cog_vid_discrete) 0I7)
        */
        val initialValues = takeFirstAndSecondLetStm(localColorRegs)
        val ifStm = takeFirstIfStm()
        val setRegs = takeFirstAndSecondLetStm(basebandAndComposite)
        if (ifStm.matchingCase(0UL).body.isNotEmpty())
            throw Exception("else body must be empty")
        val trueCase = ifStm.matchingCase(1UL).body
        if (trueCase.size != 2)
            throw Exception("if body must contain 2 stms")
        val firstTrueStm = trueCase.first()
        val remainingNewTrueStm = trueCase.drop(1)+setRegs
        if (firstTrueStm !is LetStatement || firstTrueStm.destVar !== varLocalColorPhs)
            throw Exception("invalid first true stm $firstTrueStm")
        val newIfStm = ifStm.modified(ifStm.expr,listOf(
            SwitchStatement.Case(listOf(1UL),initialValues+listOf(
                firstTrueStm,
                SwitchStatement(VariableExpression(varLocalColorPhs),listOf(1UL,0UL).map {
                    SwitchStatement.Case(listOf(it),remainingNewTrueStm)
                })
            )),
            SwitchStatement.Case(listOf(0UL),initialValues+setRegs)
        ))
        return removeUnsuedLocals(extractCommonStmInIf(simplifyFunction(f2.modified(listOf(newIfStm)+tmpBody),PartialValueVarState())))
    }
    val tr1=transformIfToMux(transformLocalColorPhs(origF))
    val tr2=extractBooleanVar(tr1,"loc_cog_vid_local_new_set") {
        fSetR0, valueSetR ->
        val fSetR1 = moveMatchingStatementsDown(fSetR0) { it is LetStatement && it.destVar.name == "reg_cog_vid_phase" }
        if (valueSetR) {
            removeUnsuedLocals(simplifyFunction(transformIfToMux(fSetR1),PartialValueVarState()))
        }
        else {
            val regVidCapr = fSetR1.getVariableByName("reg_cog_vid_capr")
            val fSetR2 = removeUnsuedLocals(simplifyFunction(forceTransformIfToMux(fSetR1,fSetR1.getVariableByName("loc_cog_vid_local_capr_next")),PartialValueVarState()))
            val fSetR3 = simplifyFunction(fSetR2.modified(mapStmList(fSetR2.body) {
                if (it is LetStatement && it.destVar === regVidCapr && it.expr is MuxExpression && it.expr.falseExpr is VariableExpression && it.expr.falseExpr.variable === regVidCapr)
                    SwitchStatement(it.expr.condition,listOf(
                        SwitchStatement.Case(listOf(1UL),listOf(LetStatement(regVidCapr,it.expr.trueExpr))),
                        SwitchStatement.Case(listOf(0UL),listOf(LetStatement(regVidCapr,it.expr.falseExpr)))
                    ))
                else
                    it

            }), PartialValueVarState())
            extractBooleanVar(fSetR3,"loc_cog_vid_local_new_cnt") {
                fCnt, _ -> fCnt

            }
        }
    }
    //println(serializeILang(tr2))
    val vidChromaVar = VariableExpression(origF.getVariableByName("reg_cog_vid_vcfg_chroma"))
    return replaceVariablesByExpression(tr2, hashMapOf(
        origF.getVariableByName("reg_cog_vid_vcfg_chroma0") to opTestBit32(vidChromaVar, opConst32(0UL)),
        origF.getVariableByName("reg_cog_vid_vcfg_chroma1") to opTestBit32(vidChromaVar, opConst32(1UL)),
        origF.getVariableByName("reg_cog_vid_vcfg_cmode") to opTestBit32(vidChromaVar, opConst32(2UL))
    ))
}

class SplittedCogAsyncVid(inputF:Function) {
    val asyncVid = FunctionPatchesList(8,"cogAsyncVid")
    init {
        val savedPixels = VariableExpression(inputF.getVariableByName("reg_cog_vid_saved_pixels"))
        val savedColors = VariableExpression(inputF.getVariableByName("reg_cog_vid_saved_colors"))
        fun verifySame(oldExpr:Expression, newExpr:Expression) {
            for (col in 0 until 4) {
                val oldE = partialEvaluateExpression(oldExpr,PartialValueVarState().setPartialValueInitialConstraint(savedPixels.variable,PartialValue(savedPixels.variable.dataType,col.toULong(),0x3UL.inv()))).expr
                val newE = partialEvaluateExpression(newExpr,PartialValueVarState().setPartialValueInitialConstraint(savedPixels.variable,PartialValue(savedPixels.variable.dataType,col.toULong(),0x3UL.inv()))).expr
                if (!oldE.isSameExpression(newE))
                    throw Exception("expression mismatch: $oldExpr // $newExpr // $col")
            }
        }
        fun transformVidDiscrete(expr:Expression):Expression {
            val newExpr = if (expr.toILang() == "(and32 (mux32 (testBit32 reg_cog_vid_saved_pixels 0I0) (shr32 reg_cog_vid_saved_colors 0I8) reg_cog_vid_saved_colors) 0Iff)")
                opAnd32(opShr32(savedColors, opShl32(opAnd32(savedPixels, opConst32(1UL)), opConst32(3UL))), opConst32(0xFFUL))
            else if (expr.toILang() == "(mux32 (eq32 (and32 reg_cog_vid_saved_pixels 0I3) 0I3) (shr32 reg_cog_vid_saved_colors 0I18) (and32 (mux32 (eq32 (and32 reg_cog_vid_saved_pixels 0I3) 0I2) (shr32 reg_cog_vid_saved_colors 0I10) (mux32 (testBit32 reg_cog_vid_saved_pixels 0I0) (shr32 reg_cog_vid_saved_colors 0I8) reg_cog_vid_saved_colors)) 0Iff))")
                opAnd32(opShr32(savedColors, opShl32(opAnd32(savedPixels, opConst32(3UL)), opConst32(3UL))), opConst32(0xFFUL))
            else
                throw Exception("illegal expr $expr")
            verifySame(expr,newExpr)
            return newExpr
        }

        val vidChromaVar = inputF.getVariableByName("reg_cog_vid_vcfg_chroma")
        for (chroma in 0 until 8) {
            val simplF = simplifyFunction(inputF, PartialValueVarState().setPartialValue(vidChromaVar,ILangDataType.Int32,chroma.toULong(),false))
            val simplF2 = simplF.modified(mapStmList(simplF.body) {
                if (it is LetStatement && it.destVar.name == "reg_cog_vid_discrete")
                    it.modified(transformVidDiscrete(it.expr))
                else
                    it
            })
            asyncVid.addPatch(chroma,simplF2,"C$chroma")
        }
    }
}