package special

import ilang.*
import ilang.Function

fun generateRstAndNenaFuncs(cogEvalMainNoClkNegEnaRst:Function,cogEvalMainNoClkNegEnaNoRst:Function, cogClkFunction0:Function, cogPeripheralMacro:MacroStatement, busAndPinOutVars:List<String>, stateNena:CompoundStateManager.StateCode, state0:CompoundStateManager.StateCode):List<Function> {
    val compoundStateXVar = cogEvalMainNoClkNegEnaRst.getVariableByName("compound_statex")
    val busSelState = cogEvalMainNoClkNegEnaRst.getVariableByName("bus_sel_state")
    val busSelRst = CogBusSelVersion.StoppedOtherState
    fun transformToCompoundState(f:Function):Function {
        val stateVars = listOf("match","cancel","state","running").map { f.getVariableByName(it) }
        val f1 = extractCompoundState(moveMatchingStatementsDown(f) {
            stm -> stm is LetStatement && stateVars.contains(stm.destVar)
        }, CompoundState(0,CompoundState.Running.Running,CompoundState.Cancel.Undefined,CompoundState.Match.NoMatch,CompoundState.State5OpCodeType.Unknown)) {
            newState ->
            if (newState.baseState != 0 || newState.running != CompoundState.Running.Stopped || newState.cancel != CompoundState.Cancel.NoCancel || newState.match != CompoundState.Match.NoMatch)
                throw Exception("invalid rst state transform")
            ConstantExpression(stateNena.code.toULong(),ILangDataType.Int32)
        }
        val f1Last = f1.body.lastOrNull()
        if (f1Last !is LetStatement || f1Last.destVar.name != "compound_state")
            throw Exception("illegal stm $f1Last")
        return f1.modified(f1.body.dropLast(1)+listOf(
            LetStatement(compoundStateXVar, ConstantJumpDestinationExpression(stateNena.code.toULong(),stateNena.f!!.name)),
            LetStatement(busSelState, ConstantJumpDestinationExpression(busSelRst.toStateCode(),busSelRst.toLabelName()))
        ))
    }

    val preCogClkNena = extractMacro(transformToCompoundState(removeUnsuedLocals(simplifyFunction(cogClkFunction0, PartialValueVarState(cogClkFunction0, listOf(Pair("ena", false))))).rename("cogClkNena")),cogPeripheralMacro)

    val preCogRst = transformToCompoundState(removeUnsuedLocals(
        simplifyFunction(
        removeOutputs(cogEvalMainNoClkNegEnaRst,busAndPinOutVars),
        PartialValueVarState(cogEvalMainNoClkNegEnaRst,listOf(
            Pair("posedge_clk_pll", false),
            Pair("ena", false),
            Pair("negedge_ena", true),
            Pair("posedge_vclk", false),
            Pair("posedge_snc1", false)
        ))
        ).rename("cogRst")))

    val preCogNegedgeEna = transformToCompoundState(removeUnsuedLocals(
            simplifyFunction(
            removeOutputs(cogEvalMainNoClkNegEnaNoRst, busAndPinOutVars),
            PartialValueVarState(cogEvalMainNoClkNegEnaNoRst,listOf(
                Pair("posedge_clk_pll", false),
                Pair("nres", true),
                Pair("negedge_ena",true),
                Pair("posedge_vclk",false),
                Pair("posedge_snc1",false)
            ))
            ).rename("cogNegedgeEna")))

    val cogPosedgeEna = removeUnsuedLocals(preCogNegedgeEna.modified(listOf(
        LetStatement(compoundStateXVar, ConstantJumpDestinationExpression(state0.code.toULong(),state0.f!!.name)),
        LetStatement(busSelState, ConstantJumpDestinationExpression(busSelRst.toStateCode(),busSelRst.toLabelName()))
    ))).rename("cogPosedgeEna")

    val (rstFuncs,rstMacro) = findCommonMacro(MacroType.CogReset,listOf(/*preCogClkNena,*/preCogNegedgeEna,preCogRst),false,false)

    fun addCogRebuildAsmFunctions(f:Function):Function = f.modified(f.body+listOf(MacroStatement("cogUpdateAllDynamicFunctions",true, f.registerVarSet(), listOf(), setOf(), listOf())))

    return listOf(addCogRebuildAsmFunctions(transformCogControlMacroAndResetMacro(rstMacro.toFunction(),false)))+rstFuncs.map { extractMacro(it, rstMacro) }+listOf(cogPosedgeEna)
}
